<? $version="1.7";$titre="Simulation de solde de compte";
/* ===================================================================================== */
/* Simulation.php : Simulation de compte (courant ou d'pargne)                          */
/* Version   : 1.0           Date : 15-07-2002        Auteur : Jean-Louis BATAILLE       */
/* ===================================================================================== */
/* Modification : Mise au standard HTML                                                  */
/* Version   : 1.1           Date : 01-02-2003        Auteur : Jean-Louis BATAILLE       */
/* ===================================================================================== */
/* Modification : Remplacement de la fonction CheckDate par ControleDate                 */
/* Version   : 1.2           Date : 07-07-2003        Auteur : Jean-Louis BATAILLE       */
/* ===================================================================================== */
/* Modification : Ajout de l'histogramme                                                 */
/* Version   : 1.3           Date : 12-07-2003        Auteur : Jean-Louis BATAILLE       */
/* ===================================================================================== */
/* Modification : Compatibilit Mozilla                                                  */
/* Version   : 1.4           Date : 30-09-2003        Auteur : Jean-Louis BATAILLE       */
/* ===================================================================================== */
/* Modification : Optimisation du code (sortie de $Tab_Stats[] hors de la boucle)        */
/*                Ajout de l'anne dans la date pour la prsentation de l'histogramme de */
/*                manire  viter d'ventuels doublons: mme jour mais anne diffrente */
/* Version   : 1.5           Date : 14-12-2003        Auteur : Jean-Louis BATAILLE       */
/* ===================================================================================== */
/* Modification : Compatibilit EasyPHP 1.7 (PHP 4.3.3)                                  */
/* Version   : 1.6           Date : 22-01-2004        Auteur : Jean-Louis BATAILLE       */
/* ===================================================================================== */
/* Modification : Dtection de la bibliothque GD des fonctions graphiques               */
/* Version   : 1.7           Date : 02-02-2004        Auteur : Jean-Louis BATAILLE       */
/* ===================================================================================== */
session_start();
include("./Includes/Comptes_data.php");    //Constantes de l'application
include("./Includes/MySQL_functions.php"); //Fonctions d'accs  MySQL
include("./Includes/Draw_Histogramme_Monoserie.php"); //Fonctions de prsentation de statistiques sous forme d'histogramme
$dblk=connect();send_sql("USE ".$db);      //Connexion et Slection de la base de donnes

if (isset($_POST['DateDebSim'])) $DateDebSim=$_POST['DateDebSim'];
else {
 if (isset($_SESSION['DateDebSim'])) $DateDebSim=$_SESSION['DateDebSim'];
 else $DateDebSim=date("d-m-Y",mktime(0,0,0,date("m"),date("d"),date("Y"))+24*3600);
}
$_SESSION['DateDebSim']=$DateDebSim;
include("./Includes/Recup_Comptes.php");   //Rcupration des comptes $Comptes et $Compte
/* ---------------------------------------------------------------------------------------- */
/* Rcupration des prvisions du compte : $rsSimuls                                        */
/* ---------------------------------------------------------------------------------------- */
  $sql="SELECT IdMvt,DateVal,DateMvt,LibMvt,ModMvt,TypMvt,MntMvt,SensMvt FROM Mouvement ";
  $sql=$sql."WHERE IdCpt='".$_SESSION['CompteRefer'];
  $sql=$sql."' and (MajSolde!='O' or DateVal>='".invDate($DateDebSim,'-','AAMJ')."') ORDER BY DateVal,IdMvt";
  $rsSimuls=send_sql($sql);
?> 
<HTML>
<HEAD>
<TITLE>Simulation du compte</TITLE>
<META name="description" content="Liste des transactions  venir ou n'ayant pas mis  jour le solde du compte">
<META name="keywords" content="">
<LINK rel="stylesheet" type="TEXT/CSS" href="EasyStyle.css">
<script language="javascript">
<? include("./Includes/ControleDate.js");  //ControleDate(d) : Contrle du format JJ-MM-AAAA de la date d
   include("./Includes/AddDelai.js");        //AddDelai(d,D) : Retourne une date au format JJ-MM-AAAA en ajoutant un dlai D (nombre de jours)  une date d au format JJ-MM-AAAA
?>
/* ---------------------------------------------------------------------------------------- */
/* Contrle des valeurs des champs du formulaire                                            */
/* ---------------------------------------------------------------------------------------- */
function control_saisie(form) {
 if (form.DateDebSim.value=="") {
  alert("La date de dbut de simulation est une information  saisir obligatoirement au format JJ-MM-AAAA")
  form.DateDebSim.focus();
  return false;
 } 
 if (!ControleDate(form.DateDebSim.value)) {
  alert("La date de dbut de simulation est une information  saisir obligatoirement au format JJ-MM-AAAA");
  form.DateDebSim.focus();
  return false;
 }
}
/* ---------------------------------------------------------------------------------------- */
/* Changement de la DATE DE DEBUT DE SIMULATION                                             */
/* ---------------------------------------------------------------------------------------- */
function DateDebSim_Change(DateDebSim) {
 if (!ControleDate(DateDebSim.value)) {
  alert("La date de dbut de simulation est une information  saisir obligatoirement au format JJ-MM-AAAA");
  DateDebSim.focus();
  return;
 }
}
function DateDebSim_Moins_Click(DateDebSim) {
 if (!ControleDate(DateDebSim.value)) {
  alert("La date de dbut de simulation est une information  saisir obligatoirement au format JJ-MM-AAAA");
  DateDebSim.focus();
  return;
 }
 DateDebSim.value=AddDelai(DateDebSim.value,-1);
}
function DateDebSim_Plus_Click(DateDebSim) {
 if (!ControleDate(DateDebSim.value)) {
  alert("La date de dbut de simulation est une information  saisir obligatoirement au format JJ-MM-AAAA");
  DateDebSim.focus();
  return;
 }
 DateDebSim.value=AddDelai(DateDebSim.value,1);
}
</script>
</HEAD>
<BODY onLoad="top.document.title='<? echo $titre; ?>';window.defaultStatus=top.document.title">
<!-- Dbut du formulaire ---------------------------------------------------------------------->
<form action="SelectCompte.php" method="post">
<? include("./Includes/TenueCompte.php"); ?> <!-- Entte slection du compte -->
<input type="hidden" name="Fonct" value="S"> <!-- Transmission  SelectCompte.php -->
</form>
<form id="seldatedeb" action="<? echo $_SERVER['PHP_SELF']; ?>" method="post" onSubmit="return control_saisie(this)">
<table border=0 cellspacing=0 cellpadding=0>
 <tr><? if (extension_loaded("gd")){ ?>
         <td class=tdleft><a href="#Histo" title="Reprsentation graphique">Histogramme</a>
             &nbsp;&nbsp;&nbsp;&nbsp;</td><?
        } ?>
  <td class=tdleft>
   <a href="Help/Simulation_hlp.htm" title="De quoi s'agit-il ?" target="_blank">Aide</a>&nbsp;&nbsp;&nbsp;&nbsp;</td>
<? include("./Includes/Aproposde.php"); ?>    <!-- Bote de message A propos de -->
  <td class=tdleft>&nbsp;</td><td class=tdleft>&nbsp;</td><td class=tdleft>&nbsp</td>
  <td class=tdleft>Dbut de simulation</td>
  <td class=tdleft>
   <BUTTON TYPE="BUTTON" name="DateDebSim_Moins"
    onMouseOver="javascript:window.status='Retirer 1 jour  la date de dbut de simulation'"
    onClick="javascript:DateDebSim_Moins_Click(DateDebSim)"><img src="<? echo $Gauche; ?>" alt="Gauche"></BUTTON>
   <INPUT TYPE="TEXT" name="DateDebSim" SIZE="10" maxlength="10" value="<? echo $DateDebSim; ?>"
    onMouseOver="javascript:window.status='Date de dbut de simulation'"
    onChange="javascript:DateDebSim_Change(DateDebSim)">&nbsp;
   <BUTTON TYPE="BUTTON" name="DateDebSim_Plus"
    onMouseOver="javascript:window.status='Ajouter 1 jour  la date de dbut de simulation'"
    onClick="javascript:DateDebSim_Plus_Click(DateDebSim)"><img src="<? echo $Droite; ?>" alt="Droite"></BUTTON></td>
  <td class=tdleft>
   <button type="submit" name="Recalculer_button">Recalculer</button></td></tr>
</table>
<hr size=2 width="100%"> <!------------------------------------------------------->
<table border=0 cellspacing=1 cellpadding=0>
 <tr>
  <th class=thcenter>&nbsp</th>
  <th class=thcenter>Valeur</th>
  <th class=thcenter>Date</th>
  <th class=thcenter>Libell</th>
  <th class=thcenter>Mode</th>
  <th class=thcenter>Type</th>
  <th class=thcenter>Dpense</th>
  <th class=thcenter>Recette</th>
  <th class=thcenter>Solde</th>
 </tr>
<?
$bgcolor="#99CCFF";$i=0;unset($Simuls);$Solde=$Compte['SoldReel'];$DateVal_old="";$SumDep=0;$SumRec=0;
$sql="SELECT SensMvt,Sum(MntMvt) as SumMnt FROM Mouvement WHERE IdCpt='".$_SESSION['CompteRefer'];
$sql=$sql."' and MajSolde='O' and DateVal>='".invDate($DateDebSim,'-','AAMJ')."' GROUP BY SensMvt";
$res=send_sql($sql);
while($record=mysql_fetch_array($res,MYSQL_ASSOC)) {
 ($record['SensMvt']=='D') ? $SumDep=-$record['SumMnt'] : $SumRec=-$record['SumMnt'];
} ?>
<tr bgcolor="<? echo $bgcolor; ?>"><td></td>
 <td class=tdleft colspan="5"><b>Transactions  dcompter</b></td>
 <td class=tdright><b><? echo formDec2($SumDep)." ".$Compte['Format']; ?></b></td>
 <td class=tdright><b><? echo formDec2($SumRec)." ".$Compte['Format']; ?></b></td><?
$Solde=$Solde-$SumDep+$SumRec;($Solde < 0) ? $rouge=" style=\"color:#FF6600\"" : $rouge=""; ?>
 <td class=tdright <? echo $rouge; ?>><b><? echo formDec2($Solde)." ".$Compte['Format']; ?></b></td>
</tr><? // $Simuls[$i++]="D"; // Dcompter

while($record=mysql_fetch_array($rsSimuls,MYSQL_ASSOC)) {
 if ($record['DateVal']!=$DateVal_old) ($bgcolor == "#99CCFF") ? $bgcolor="#CCFFFF" : $bgcolor="#99CCFF";$puce="puce_".$i; ?>
 <tr bgcolor="<? echo $bgcolor; ?>">
 <td class=tdleft><a href="Simul.php?PosSim=<? echo $i; ?>"
		title="Accs aux caractristiques de la transaction"
		onMouseOver="document.images.<? echo $puce; ?>.src='<? echo $Pointrouge; ?>'"
		onMouseOut="document.images.<? echo $puce; ?>.src='<? echo $Pointbleu; ?>'">
   		<img id="<? echo $puce; ?>" border=0 width=12 height=12 src="<? echo $Pointbleu; ?>" name="<? echo $puce; ?>" alt="Pointbleu"></a></td><?
 foreach($record as $fld=>$field) {
  switch ($fld) {
   case "IdMvt"  :break;
   case "SensMvt":break;
   case "DateMvt":echo "<td class=tdcenter>",invDate($field,"-","JMAA"),"</td>";break;
   case "TypMvt" :echo "<td class=tdcenter>",$field,"</td>";break;
   case "DateVal":
    if ($field==$DateVal_old) echo "<td></td>";
    else echo "<td class=tdcenter>",invDate($field,"-","JMAA"),"</td>";
    $DateVal_old=$field;break;
   case "MntMvt":
    if ($record['SensMvt']=="D") { $Depense=$field." ".$Compte['Format'];$Recette="";$Solde=$Solde-$field; }
    else { $Depense="";$Recette=$field." ".$Compte['Format'];$Solde=$Solde+$field; }
    echo "<td class=tdright>",$Depense,"</td>";
    echo "<td class=tdright>",$Recette,"</td>";
    break;
   default:echo "<td class=tdleft>",$field,"</td>";
  }
 }
 $Tab_Stats[substr($record['DateVal'],8,2)."-".substr($record['DateVal'],5,2)."-".substr($record['DateVal'],2,2)]=$Solde;
 ($Solde < 0) ? $rouge="style=\"color:#FF6600\"" : $rouge=""; ?>
 <td class=tdright <? echo $rouge; ?>><? echo formDec2($Solde)." ".$Compte['Format']; ?></td>
</tr><? $Simuls[$i++]=$record['IdMvt'];
}
?>
</table><br><br>

<a name="Histo">
<? if (!isset($Simuls)) { $Simuls=Array();echo "<p>Aucune prvision en cours sur ce compte</p>"; }
   else {
    if (extension_loaded("gd")){
     $Path="Graphiques/";
     $Folder=dir($Path);
     while ($Fichier=$Folder->read()) {
      if (substr($Fichier,0,15)=="SimulationSolde") unlink($Path.$Fichier);
     }
     $Folder->close();
     $ImgLarg=400;$ImgHaut=300;$ImgMarge=10;$IntervalleLarg=2; 
     $Titre="Simulation de solde de compte";
     $CouleurNeg="#FF0000";$CouleurPos="#0000FF";
     $NbLigneAbscisse=2;$SepLigneAbscisse="-";
     $filename="Graphiques/SimulationSolde_".microtime().".png";
     if (Draw_Histogramme_Monoserie($Tab_Stats,$ImgLarg,$ImgHaut,$ImgMarge,$IntervalleLarg,$Titre,$CouleurPos,$CouleurNeg,$NbLigneAbscisse,$SepLigneAbscisse,$filename)) { ?>
       <img src="<? echo $filename; ?>" alt="Graphique"><?
     } else echo "Pas d'image";
    }
   }
   $_SESSION['Simuls']=$Simuls; ?>
</a>
</form><!-- Fin du formulaire ------------------------------------------------------------------->
</BODY>
</HTML>
